(*
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301, USA.



  Author          : xqtr
  Date            : 27/01/2017
  Description     : Weather Underground Full Info
  Version         : 1.0
  Usage           : xq-uweather
   
  Notes    
  * Needs jshon and curl package
    sudo apt-get install jshon curl
   
*)


Uses cfg;

Const
  Loc   = 'Your Location';

Var
  Ch    : Char;
  Done  : Boolean;
  Idx   : Byte;
  Path  : String;

Procedure Center(s:string; line:byte);
begin
  GotoXY(40-(length(StripMCI(s)) / 2),line);
  Write(s);
End;

Procedure MenuBar;
Begin
  TextColor(15);
  WriteXY (1, 1, 15+0*16, strRep(Chr(220), 80));
  WriteXY (1, 2, 7+7*16, StrRep(' ',80));
  WriteXY (1, 3,  8+0*16, strRep(Chr(223), 80));
End;

Procedure ClearArea;
Var
  i : Byte;
Begin
  GotoXY(1,4);
  TextColor(15);
  For i := 1 To 21 Do Write('                                                                                ');
End;

Procedure Selection(X: Byte; Text: String);
Var
  S : String;
Begin
  S := Text;
  While Length(S)<12 Do Begin
    S := ' '+S+' ';
  End;
  WriteXY(1,2,8+7*16,'    Summary    Current    Today    Tomorrow    +2 Days    +3 Days    Alert');
  WriteXY(X,1,7,'[37m[1;47m[0;37;40m[1m[47m[0;37;40m');
  WriteXY(X,2,7,'[1;47m             [0;37;40m');
  WriteXY(X,3,7,'[1;30;47m[0;37;40m[1;30;47m[40m[47m[37m[40m[0m');
  WriteXY(X+2,2,15+7*16,Text);
End;

Procedure CheckAlert;
Begin
  If FileExist(Path+'alerts.json') Then Begin
    GotoXY(68,2);
    Write('|23|04|14|20Alert|23|04');
  End;
End;

Procedure BaseLine(Text: String);
Begin
  GotoXY(1,25);
  Write('[1;37m[47m۲ [30m  [37m[30m [37m[30m    [0;30;47m'+PadCT(text,34,' ')+'[1m       [40m[0m');
End;

Begin
  //No ANSI? Then Exit
  If Graphics = 0 Then Begin
    WriteLn('|16|15No Graphics support. Exiting... |PA');
    Halt;
  End;
  Path := CfgMpePath+addslash('xq-uweather');
  ClrScr;
  WriteXY(1,1,7,'Updating Data...');
  MenuCmd('DD',Path+'wu.sh');
  MenuBar;
  ClearArea;
  Center('|08|16Press ENTER to select,',12);
  Center('|08|16or ESC to exit...',13);
  BaseLine('Weather Underground for Mystic BBS');
  Selection(1,'  Summary');
  Done := False;
  Idx  := 1;
  CheckAlert;
  Repeat 
    Ch := ReadKey
    If IsArrow Then begin
      //Home
      If Ch = Chr(71) Then Begin
        Idx := 1;
      End;
      //End
      If Ch = Chr(79) Then Begin
        Idx := 7;
      End;
      //Left
      If Ch = Chr(75) Then Begin
        Idx := Idx - 1;
        If Idx <= 0 Then Idx := 7;
      End;
      //Right
      If Ch = Chr(77) Then Begin
        Idx := Idx + 1;
        If Idx >= 8 Then Idx := 1;
      End;
      MenuBar;
      ClearArea;
      Case Idx Of
        1 : Begin
              Selection(1,'  Summary');
            End;
        2 : Begin
              Selection(12,'  Current');
            End;
        3 : Begin
              Selection(22,'   Today ');
            End;
        4 : Begin
              Selection(32,'  Tomorrow ');
            End;
        5 : Begin
              Selection(44,'  +2 Days  ');
            End;
        6 : Begin
              Selection(55,'  +3 Days  ');
            End;
        7 : Begin
              Selection(65,'   Alert ');
            End;
      End;
      Center('|08|16Press ENTER to select,',12);
      Center('|08|16or ESC to exit...',13);
      BaseLine(Loc);
      CheckAlert;
    End;
    If Ch = #27 Then Done := True;
    If Ch = #13 Then Begin
      ClearArea;
      GotoXY(1,4);
      Case Idx Of
        1 : MenuCmd('DD',Path+'wu.sh summary');
        2 : MenuCmd('DD',Path+'wu.sh current');
        3 : MenuCmd('DD',Path+'wu.sh today');
        4 : MenuCmd('DD',Path+'wu.sh 2');
        5 : MenuCmd('DD',Path+'wu.sh 3');
        6 : MenuCmd('DD',Path+'wu.sh 4');
        7 : MenuCmd('DD',Path+'wu.sh alert');
      End;
    End;
  Until Done;
  GotoXY(1,20);
End;
